Bug 34439 - ICE in reload_cse_simplify_operands for Coldfire
Summary: ICE in reload_cse_simplify_operands for Coldfire
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: target (show other bugs)
Version: 4.2.2
: P3 normal
Target Milestone: 4.3.4
Assignee: Not yet assigned to anyone
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2007-12-11 23:19 UTC by Joel Sherrill
Modified: 2009-08-23 18:34 UTC (History)
2 users (show)

See Also:
Host:
Target: m68k-unknown-rtems
Build:
Known to work:
Known to fail:
Last reconfirmed:


Attachments
Preprocessed code that produces error (24.68 KB, text/x-csrc)
2007-12-11 23:20 UTC, Joel Sherrill
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Joel Sherrill 2007-12-11 23:19:43 UTC
m68k-rtems4.9-gcc -m528x  -c j.c

gcc 4.2.2 

../../../../../../current/c/src/../../cpukit/shttpd/log.c:139: error: insn does not satisfy its constraints:
(insn 74 158 159 10 ../../../../../../current/c/src/../../cpukit/shttpd/log.c:117 (set (mem/c:SI (plus:SI (reg/f:SI 14 %a6)
                (reg:SI 1 %d1)) [57 D.6834+0 S4 A16])
        (mem/s:SI (plus:SI (reg/v/f:SI 10 %a2 [orig:48 c ] [48])
                (const_int 220 [0xdc])) [3 <variable>.loc.io.total+0 S4 A16])) 34 {*movsi_cf} (nil)
    (nil))
../../../../../../current/c/src/../../cpukit/shttpd/log.c:139: internal compiler error: in reload_cse_simplify_operands, at postreload.c:392
Comment 1 Joel Sherrill 2007-12-11 23:20:49 UTC
Created attachment 14734 [details]
Preprocessed code that produces error

This is the preprocessed output of the Simple HTTPD server for RTEMS compiled to 5282.
Comment 2 Joel Sherrill 2007-12-11 23:22:06 UTC
Also occurs on 4.2.1 but this time at:

/opt/rtems-4.8/bin/m68k-rtems4.8-gcc -m528x  -c j.c
j.c: In function '_shttpd_elog':
j.c:7557: error: insn does not satisfy its constraints:
(insn 13 189 14 (set (mem/c:SI (plus:SI (reg/f:SI 14 %a6)
                (reg:SI 0 %d0)) [0 iftmp.9+0 S4 A16])
        (mem/s/f/j:SI (plus:SI (reg:SI 8 %a0 [orig:52 D.6913 ] [52])
                (const_int 72 [0x48])) [0 <variable>.error_log+0 S4 A16])) 34 {*movsi_cf} (nil)
    (nil))
j.c:7557: internal compiler error: in final_scan_insn, at final.c:2382
Please submit a full bug report,
Comment 3 Joel Sherrill 2007-12-11 23:22:34 UTC
And again on 4.1.1:

$ /opt/rtems-4.7/bin/m68k-rtems4.7-gcc -m528x  -c j.c
j.c: In function '_shttpd_elog':
j.c:7557: error: insn does not satisfy its constraints:
(insn 14 190 15 (set (mem/c:SI (plus:SI (reg/f:SI 14 %a6)
                (reg:SI 0 %d0)) [0 iftmp.9+0 S4 A16])
        (mem/s/f/j:SI (plus:SI (reg:SI 8 %a0 [orig:52 D.6686 ] [52])
                (const_int 72 [0x48])) [0 <variable>.error_log+0 S4 A16])) 26 {*movsi_cf} (nil)
    (nil))
j.c:7557: internal compiler error: in final_scan_insn, at final.c:2410
Comment 4 Joel Sherrill 2008-08-12 19:47:09 UTC
Works with 4.3.1.  Should this be closed if someone can confirm it is fixed on the trunk?
Comment 5 Mikael Pettersson 2009-06-16 16:29:00 UTC
(In reply to comment #4)
> Works with 4.3.1.  Should this be closed if someone can confirm it is fixed on
> the trunk?

This is a generic m68k issue as I can easily reproduce the ICE using a gcc-4.2.4 based cross-compiler to m68k-unknown-linux. The current latest gcc-4.4 and gcc-4.3 weekly snapshots do not exhibit the ICE however.
Comment 6 Andreas Schwab 2009-08-23 18:34:14 UTC
No longer reproducible, assuming fixed.